<?php
 //neste arquivos, criamos a classe que representa todas as operações que serão feitas sobre os alunos cadastrados no banco de dados
 class Alunos 
  {
  public $matricula;
  public $nome;
  public $media;
  

 //vamos implementar o método que recebe os dados cadastrais do aluno, dados estes vindo do formulário. Note o uso de comandos especiais, que barram a tenativa de invasão do servidor por meio do método de Injeção de SQL
 function receberDados($conexao)
  {
  $matricula = trim($_POST['matric']);
  $nome      = trim($_POST['nome']);
  $media     = trim($_POST["media-prw2"]);

  $matricula = $conexao->escape_string($matricula);
  $nome      = $conexao->escape_string($nome);
  $media     = $conexao->escape_string($media);

  //atribuir as variáveis às propriedades da instãncia da classe
  $this->matricula = $matricula;
  $this->nome      = $nome;
  $this->media     = $media;
  }
 
 //implementando o método de cadastro dos dados de cada aluno na tabela do banco de dados
 function cadastrar($conexao, $nomeDaTabela)
  {
  $sql = "INSERT $nomeDaTabela VALUES(
           '$this->matricula',
           '$this->nome',
           $this->media)";

  $conexao->query($sql) || die($conexao->error);
  }

 //método para recuperar os registros de todos os alunos do banco de dados exibi-los na páginas web, no formato tabular
 function tabularDados($conexao, $nomeDaTabela)
  {
  //lembre-se de que a segurança da nossa aplicação web é algo muito importante. Toda vez que o PHP tentar acessar dados do banco de dados (geralmente, por meio de um SELECT) devemos fazer uma filtragem dos dados sendo recebidos, a fim de impedir o tipo de ataque conhecido como XSS
 
  $sql = "SELECT * FROM $nomeDaTabela";
  $resultado = $conexao->query($sql) OR die($conexao->error);

  echo "<table>
         <caption> Dados acadêmicos dos alunos cadastrados no banco de dados </caption>
         <tr>
          <th> Matrícula </th>
          <th> Nome do Aluno </th>
          <th> Média de PRW II </th>
         </tr>";

  //para retirarmos os dados do objeto $resultado e colocarmos estes dados em cada célula da tabela web, utilizaremos a estrutura while, com o método fetch_array() do objeto $resultado
  while($vetorRegistro = $resultado->fetch_array())
   {
   //antes de exibir os dados do vetor na tabela da página web, vamos sanitizá-los, a fim de evitarmos o ataque do tipo XSS
   $matric = $vetorRegistro[0];
   $aluno  = $vetorRegistro['nome']; //ou $aluno = $vetorRegistro[1]
   $media  = $vetorRegistro[2];

   $matric = htmlentities($matric, ENT_QUOTES, "UTF-8");
   $aluno  = htmlentities($aluno, ENT_QUOTES, "UTF-8");
   $media  = htmlentities($media, ENT_QUOTES, "UTF-8");

   echo "<tr>
          <td> $matric </td>
          <td> $aluno </td>
          <td> $media </td>
         </tr>";
   }
  echo "</table>";
  }

 //implementar o método que conta o número de alunos aprovados
 function contarAprovados($conexao, $nomeDaTabela)
  {
  $sql = "SELECT COUNT(*) FROM $nomeDaTabela WHERE media >= 6";
  $resultado = $conexao->query($sql) OR exit($conexao->error);
  $vetorRegistro = $resultado->fetch_array();
  $numeroAprovados = $vetorRegistro[0];
  $numeroAprovados = htmlentities($numeroAprovados, ENT_QUOTES, "UTF-8");
  echo "<p> De acordo com os dados dos alunos cadastrados no banco de dados, temos um total de <span> $numeroAprovados </span> alunos aprovados. </p>";
  }
 }
